/*
 XTTTTTTTTTTTTTT[
                          U   ˵   U                          
 ^TTTTTTTTTTTTTTaȨ
                         inanbo Technology						   						 
  ..........: STM32F103 TFT Test                                
  ..........: Mr.Rambo                                          
  ..........: Mr.Zhong                                          
  ......: Keil uVision4                                     
  վ..........: www.inanbo.com                                    
                                                                    
  RELEASE DATE..: 26/04/2011                                        
 

*/

#include "GLCD.h"
#include "stdlib.h"
#include "font.h" 
					 
u16 POINT_COLOR = 0x0000,BACK_COLOR = 0xFFFF;  
u16 DeviceCode;	 

#if LCD_FAST_IO==1 //IO

void delay_us(int c)
{
	delay_ms(c/10);
}

void delay_ms (int cnt) {

  cnt <<= 13;
  while (cnt--);
}

//дĴ
void LCD_WR_REG(u8 data)
{ 
	LCD_RS_CLR;//дַ  
 	LCD_CS_CLR; 
	DATAOUT(data); 
	LCD_WR_CLR; 
	LCD_WR_SET; 
 	LCD_CS_SET;   
}
#else//IO
//дĴ
void LCD_WR_REG(u8 data)
{ 
	LCD_RS=0;//дַ  
 	LCD_CS=0; 
	DATAOUT(data); 
	LCD_WR=0; 
	LCD_WR=1; 
 	LCD_CS=1;   
} 	
#endif	   
//LCD
//ֵ:ֵ
u16 LCD_RD_DATA(void)
{										   
	u16 t;
 	GPIOB->CRL=0X88888888; //PB0-7  
	GPIOB->CRH=0X88888888; //PB8-15 
	GPIOB->ODR=0X0000;     //ȫ0
#if LCD_FAST_IO==1 //IO
	LCD_RS_SET;
	LCD_CS_CLR;
	//ȡ(Ĵʱ,Ҫ2)
	LCD_RD_CLR;
					   
	LCD_RD_SET;
	t=DATAIN;  
	LCD_CS_SET; 
#else
	LCD_RS=1;
	LCD_CS=0;
	//ȡ(Ĵʱ,Ҫ2)
	LCD_RD=0;					   
	LCD_RD=1;
	t=DATAIN;  
	LCD_CS=1; 
#endif  
	GPIOB->CRL=0X33333333; //PB0-7  
	GPIOB->CRH=0X33333333; //PB8-15 
	GPIOB->ODR=0XFFFF;    //ȫ
	return t;  
}	

//дĴ
//LCD_Reg:Ĵ
//LCD_RegValue:Ҫдֵ
void LCD_WriteReg(u8 LCD_Reg, u16 LCD_RegValue)
{	
	LCD_WR_REG(LCD_Reg);  
	LCD_WR_DATA(LCD_RegValue);	    		 
}
//Ĵ
//LCD_Reg:Ĵ
//ֵ:ֵ
u16 LCD_ReadReg(u8 LCD_Reg)
{										   
 	LCD_WR_REG(LCD_Reg);  //дҪļĴ  
	return LCD_RD_DATA(); 
}
//ʼдGRAM
void LCD_WriteRAM_Prepare(void)
{
	LCD_WR_REG(0x2C);//ILI94880X2Cʼ 0x2Eʼ	
}
//LCDдGRAM
//RGB_Code:ɫֵ
void LCD_WriteRAM(u16 RGB_Code)
{							    
	LCD_WR_DATA(RGB_Code);//дʮλGRAM
}
//ILI93xxΪGBRʽдʱΪRGBʽ
//ͨúת
//c:GBRʽɫֵ
//ֵRGBʽɫֵ
u16 LCD_BGR2RGB(u16 c)
{
	u16  r,g,b,rgb;   
	b=(c>>0)&0x1f;
	g=(c>>5)&0x3f;
	r=(c>>11)&0x1f;	 
	rgb=(b<<11)+(g<<5)+(r<<0);		 
	return(rgb);
}
		 
//ȡĳɫֵ	 
//x:0~239
//y:0~319
//ֵ:˵ɫ
u16 LCD_ReadPoint(u16 x,u16 y)
{
 	u16 r,g,b;
	if(x>=LCD_W||y>=LCD_H)return 0;			//˷Χ,ֱӷ		   
	LCD_SetCursor(x,y,x,y);
	LCD_WR_REG(0X2E);	//ILI9341ͶGRAMָ
	
	GPIOB->CRL=0X88888888; //PB0-7  
	GPIOB->CRH=0X88888888; //PB8-15 
	GPIOB->ODR=0XFFFF;     //ȫ
#if LCD_FAST_IO==1 //IO
	LCD_RS_SET;
	LCD_CS_CLR;
	//ȡ(GRAMʱ,һΪٶ)	
	LCD_RD_CLR;	
  	LCD_RD_SET;
 	//dummy READ
	LCD_RD_CLR;					   
			   
	LCD_RD_SET;
 	r=DATAIN;  
 	
		LCD_RD_CLR;					   
	 	LCD_RD_SET;
		b=DATAIN;//ȡɫֵ  	  
		g=r&0XFF;//9341,һζȡRGֵ,Rǰ,Gں,ռ8λ
		g<<=8;
	
	LCD_CS_SET;
#else
	LCD_RS=1;
	LCD_CS=0;
	//ȡ(GRAMʱ,Ҫ2)
	LCD_RD=0;					   
 	LCD_RD=1;
 	//dummy READ
	LCD_RD=0;					   
 	LCD_RD=1;
	r=DATAIN;  
 	 
		LCD_RD=0;					   
	 	LCD_RD=1;
		b=DATAIN;//ȡɫֵ  	  
		g=r&0XFF;//9341,һζȡRGֵ,Rǰ,Gں,ռ8λ
		g<<=8;
	
	LCD_CS=1;
#endif 
	GPIOB->CRL=0X33333333; //PB0-7  
	GPIOB->CRH=0X33333333; //PB8-15 
	GPIOB->ODR=0XFFFF;    //ȫ  
	return (((r>>11)<<11)|((g>>10)<<5)|(b>>11));						//ILI9341Ҫʽתһ
	
}
//LCDʾ
void LCD_DisplayOn(void)
{	
	LCD_WR_REG(0X29);	//ʾ
	
}
//LCDرʾ
void LCD_DisplayOff(void)
{	   
	LCD_WR_REG(0X28);	//رʾ	
}   

void LCD_SetDrawPoint(u16 Xpos, u16 Ypos)
{
	LCD_WR_REG(0x2a);   
	LCD_WR_DATA(Xpos>>8);
	LCD_WR_DATA(Xpos&0xff);
	LCD_WR_DATA(Xpos>>8);
	LCD_WR_DATA(Xpos&0xff);

	LCD_WR_REG(0x2b);   
	LCD_WR_DATA(Ypos>>8);
	LCD_WR_DATA(Ypos&0xff);
	LCD_WR_DATA(Ypos>>8);
	LCD_WR_DATA(Ypos&0xff);
}
//ùλ
//Xpos:
//Ypos:
void LCD_SetCursor(u16 Xpos, u16 Ypos, u16 XEnd, u16 YEnd)
{
	
	/*
#if USE_HORIZONTAL==1 
		LCD_WR_REG(0x2B); 
		LCD_WR_DATA(Ypos>>8); 
		LCD_WR_DATA(Ypos&0XFF);			 
		LCD_WR_REG(0x2A); 
		LCD_WR_DATA(Xpos>>8); 
		LCD_WR_DATA(Xpos&0XFF);
#else
		LCD_WR_REG(0x2A); 
		LCD_WR_DATA(Xpos>>8); 
		LCD_WR_DATA(Xpos&0XFF);	 
		LCD_WR_REG(0x2B); 
		LCD_WR_DATA(Ypos>>8); 
		LCD_WR_DATA(Ypos&0XFF);
#endif
	*/
	
	//ILI9488
	LCD_WR_REG(0x2a);   
	LCD_WR_DATA(Xpos>>8);
	LCD_WR_DATA(Xpos&0xff);
	LCD_WR_DATA(XEnd>>8);
	LCD_WR_DATA(XEnd&0xff);

	LCD_WR_REG(0x2b);   
	LCD_WR_DATA(Ypos>>8);
	LCD_WR_DATA(Ypos&0xff);
	LCD_WR_DATA(YEnd>>8);
	LCD_WR_DATA(YEnd&0xff);
	
/*
	LCD_WR_REG(0x3A);    // 16/18 bits
  LCD_WR_DATA(0x55);

	LCD_WR_REG(0x2c);
	*/
}

//LCDԶɨ跽
//ע:ܻܵ˺õӰ(9341),,
//һΪL2R_U2D,Ϊɨ跽ʽ,ܵʾ.
//0~78(嶨lcd.h)
//9320/9325/9328/4531/4535/1505/b505/8989/5408/9341ICѾʵʲ	   
void LCD_Scan_Dir(u8 dir)
{
	u16 regval=0;
	u8 dirreg=0;
#if USE_HORIZONTAL//ʹú
	switch(dir)//ת
	{
		case 0:dir=6;break;
		case 1:dir=7;break;
		case 2:dir=4;break;
		case 3:dir=5;break;
		case 4:dir=1;break;
		case 5:dir=0;break;
		case 6:dir=3;break;
		case 7:dir=2;break;	     
	}
#endif
	if(DeviceCode==0x9341)//9341,
	{
		switch(dir)
		{
			case L2R_U2D://,ϵ
				regval|=(0<<7)|(0<<6)|(0<<5); 
				break;
			case L2R_D2U://,µ
				regval|=(1<<7)|(0<<6)|(0<<5); 
				break;
			case R2L_U2D://ҵ,ϵ
				regval|=(0<<7)|(1<<6)|(0<<5); 
				break;
			case R2L_D2U://ҵ,µ
				regval|=(1<<7)|(1<<6)|(0<<5); 
				break;	 
			case U2D_L2R://ϵ,
				regval|=(0<<7)|(0<<6)|(1<<5); 
				break;
			case U2D_R2L://ϵ,ҵ
				regval|=(0<<7)|(1<<6)|(1<<5); 
				break;
			case D2U_L2R://µ,
				regval|=(1<<7)|(0<<6)|(1<<5); 
				break;
			case D2U_R2L://µ,ҵ
				regval|=(1<<7)|(1<<6)|(1<<5); 
				break;	 
		}
		dirreg=0X36;
 		regval|=0X08;//BGR   
		LCD_WriteReg(dirreg,regval);
		if(regval&0X20)
		{
 	 		LCD_WR_REG(0x2A); 
			LCD_WR_DATA(0);LCD_WR_DATA(0);
			LCD_WR_DATA(319>>8);LCD_WR_DATA(319&0XFF);
	 		LCD_WR_REG(0x2B); 
			LCD_WR_DATA(0);LCD_WR_DATA(0);
			LCD_WR_DATA(239>>8);LCD_WR_DATA(239&0XFF);
		}else 
		{
 	 		LCD_WR_REG(0x2A); 
			LCD_WR_DATA(0);LCD_WR_DATA(0);
			LCD_WR_DATA(239>>8);LCD_WR_DATA(239&0XFF);
	 		LCD_WR_REG(0x2B); 
			LCD_WR_DATA(0);LCD_WR_DATA(0);
			LCD_WR_DATA(319>>8);LCD_WR_DATA(319&0XFF);
		}  
 	}else 
	{
		switch(dir)
		{
			case L2R_U2D://,ϵ
				regval|=(1<<5)|(1<<4)|(0<<3); 
				break;
			case L2R_D2U://,µ
				regval|=(0<<5)|(1<<4)|(0<<3); 
				break;
			case R2L_U2D://ҵ,ϵ
				regval|=(1<<5)|(0<<4)|(0<<3);
				break;
			case R2L_D2U://ҵ,µ
				regval|=(0<<5)|(0<<4)|(0<<3); 
				break;	 
			case U2D_L2R://ϵ,
				regval|=(1<<5)|(1<<4)|(1<<3); 
				break;
			case U2D_R2L://ϵ,ҵ
				regval|=(1<<5)|(0<<4)|(1<<3); 
				break;
			case D2U_L2R://µ,
				regval|=(0<<5)|(1<<4)|(1<<3); 
				break;
			case D2U_R2L://µ,ҵ
				regval|=(0<<5)|(0<<4)|(1<<3); 
				break;	 
		}
		
		
			dirreg=0X03;
			regval|=1<<12;  
		
		LCD_WriteReg(dirreg,regval);
	}
} 
//
//x:0~239
//y:0~319
//POINT_COLOR:˵ɫ
void LCD_DrawPoint(u16 x,u16 y)
{
	//LCD_SetCursor(x,y);//ùλ 
	LCD_SetDrawPoint(x,y);
	LCD_WriteRAM_Prepare();	//ʼдGRAM
	LCD_WR_DATA(POINT_COLOR); 
} 	


__inline void wr_dat (unsigned short c) {

	Set_Rs;
	Set_nRd;
  	GPIOE->ODR = c;
	Clr_nWr;
	Set_nWr;
}

/*******************************************************************************
* Write command to LCD controller                                              *
*   Parameter:    c:      command to be written                                *
*   Return:                                                                    *
*******************************************************************************/

__inline void wr_cmd (unsigned char c) {

	Clr_Rs;
	Set_nRd;
	GPIOE->ODR = c;
	Clr_nWr;
	Set_nWr;
}

/*******************************************************************************
* Read data from LCD controller                                                *
*   Parameter:                                                                 *
*   Return:               read data                                            *
*******************************************************************************/

__inline unsigned short rd_dat (void) {
  unsigned short val = 0;

	Set_Rs;
	Set_nWr;
	Clr_nRd;
    GPIOE->CRH = 0x44444444;
	GPIOE->CRL = 0x44444444;
	val = GPIOE->IDR;
	val = GPIOE->IDR;
	GPIOE->CRH = 0x33333333;
	GPIOE->CRL = 0x33333333;
	Set_nRd;
	return val;
}

extern unsigned int BGR2RGB(unsigned int c)
{
	unsigned int  r, g, b, rgb;

	b = (c>>0)  & 0x1f;
	g = (c>>5)  & 0x3f;
	r = (c>>11) & 0x1f;

	rgb =  (b<<11) + (g<<5) + (r<<0);

	return( rgb );
}

/*******************************************************************************
* Write to LCD register                                                        *
*   Parameter:    reg:    register to be read                                  *
*                 val:    value to write to register                           *
*******************************************************************************/

__inline void wr_reg (unsigned char reg, unsigned short val) {

  	Clr_Cs;
	wr_cmd(reg);      
	wr_dat(val);    
	Set_Cs; 
}


/*******************************************************************************
* Read from LCD register                                                       *
*   Parameter:    reg:    register to be read                                  *
*   Return:               value read from register                             *
*******************************************************************************/

unsigned short rd_reg (unsigned short reg) {

  	Clr_Cs;
	wr_cmd(reg);     
	reg = rd_dat();      	
	Set_Cs;
	return reg;
}



//ʼlcd
//óʼԳʼILI93XXҺ,ǻILI9320!!!
//ͺŵоƬûв! 
void LCD_Init(void)
{  
	int devicecode; 
	
	GPIO_InitTypeDef GPIO_InitStructure;

 	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOE|RCC_APB2Periph_GPIOD|RCC_APB2Periph_AFIO, ENABLE); 
	GPIO_PinRemapConfig(GPIO_Remap_SWJ_JTAGDisable , ENABLE);
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_15|GPIO_Pin_14|GPIO_Pin_13|GPIO_Pin_12;	   //GPIO_Pin_10
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;  //
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOD, &GPIO_InitStructure); //GPIOC	
	GPIO_SetBits(GPIOD,GPIO_Pin_15|GPIO_Pin_14|GPIO_Pin_13|GPIO_Pin_12);


	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_All;	//  
	GPIO_Init(GPIOE, &GPIO_InitStructure); //GPIOB
	//GPIO_WriteBit(GPIOC,GPIO_Pin_All,Bit_SET); 
	GPIO_SetBits(GPIOE,GPIO_Pin_All);
 
	delay_ms(5); // delay 50 ms 
	LCD_WriteReg(0x0000,0x0001);
	delay_ms(5); // delay 50 ms 
	DeviceCode = LCD_ReadReg(0x0000);  
		
	/*
	
	RCC->APB2ENR |= 0x0000007D;
	
	
	GPIOE->CRL = 0x33333333;	    //PEΪ50Mͨģʽ
	GPIOE->CRH = 0x33333333;
	
	GPIOD->CRH &= 0x0000ffff;	    //PD12,PD13,14,15Ϊ50Mͨģʽ
	GPIOD->CRH |= 0x33330000;
	
	GPIOD->BSRR = 0x0000F000;		//cs,rs,wr,rd = 1;
	*/
	
	delay_ms(5); // delay 50 ms 
	LCD_WriteReg(0x0000,0x0001);
	delay_ms(5); // delay 50 ms 
	DeviceCode = rd_reg(0x0004);   
	DeviceCode = rd_reg(0x0004);
	DeviceCode = rd_reg(0x0004);
	DeviceCode = rd_reg(0x0004);
	

	LCD_WR_REG(0X04);				   
	LCD_RD_DATA(); 			//dummy read 	
	DeviceCode=LCD_RD_DATA();//0XD3,ʵ0X93Ŷ.ǿȥ6λ   								   
	DeviceCode=LCD_RD_DATA();	
	DeviceCode=LCD_RD_DATA();	
	
	LCD_WR_REG(0xE0); 
	LCD_WR_DATA(0x00); 
	LCD_WR_DATA(0x0E); 
	LCD_WR_DATA(0x15); 
	LCD_WR_DATA(0x06); 
	LCD_WR_DATA(0x13); 
	LCD_WR_DATA(0x09); 
	LCD_WR_DATA(0x3A); 
	LCD_WR_DATA(0xAC); 
	LCD_WR_DATA(0x4F); 
	LCD_WR_DATA(0x05); 
	LCD_WR_DATA(0x0D); 
	LCD_WR_DATA(0x0B); 
	LCD_WR_DATA(0x33); 
	LCD_WR_DATA(0x3B); 
	LCD_WR_DATA(0x0F);  
	 
	LCD_WR_REG(0xE1); 
	LCD_WR_DATA(0x00); 
	LCD_WR_DATA(0x0E); 
	LCD_WR_DATA(0x16); 
	LCD_WR_DATA(0x05); 
	LCD_WR_DATA(0x13); 
	LCD_WR_DATA(0x08); 
	LCD_WR_DATA(0x3B); 
	LCD_WR_DATA(0x9A); 
	LCD_WR_DATA(0x50); 
	LCD_WR_DATA(0x0A); 
	LCD_WR_DATA(0x13); 
	LCD_WR_DATA(0x0F); 
	LCD_WR_DATA(0x31); 
	LCD_WR_DATA(0x36); 
	LCD_WR_DATA(0x0F); 

	LCD_WR_REG(0xC0); 
	LCD_WR_DATA(0x10); 
	LCD_WR_DATA(0x10); 
	 
	LCD_WR_REG(0xC1); 
	LCD_WR_DATA(0x44); 

	LCD_WR_REG(0xC5); 
	LCD_WR_DATA(0x00); 
	LCD_WR_DATA(0x10); 
	LCD_WR_DATA(0x80); 

	LCD_WR_REG(0x36); 
	//LCD_WR_DATA(0x08); 
	LCD_WR_DATA(0x68); 

	LCD_WR_REG(0x3A);//Interface Mode Control
	LCD_WR_DATA(0x55);

	LCD_WR_REG(0x21); 

	LCD_WR_REG(0XB0);  //Interface Mode Control  
	LCD_WR_DATA(0x00); 
	LCD_WR_REG(0xB1);   //Frame rate 70HZ  
	LCD_WR_DATA(0xB0); 

	LCD_WR_REG(0xB4); 
	LCD_WR_DATA(0x02);   
	LCD_WR_REG(0xB6); //RGB/MCU Interface Control
	LCD_WR_DATA(0x02); 
	LCD_WR_DATA(0x22); 

	LCD_WR_REG(0xB7); 
	LCD_WR_DATA(0xC6); 

	LCD_WR_REG(0XBE);
	LCD_WR_DATA(0x00);
	LCD_WR_DATA(0x04);

	LCD_WR_REG(0xE9); 
	LCD_WR_DATA(0x00);
	 
	LCD_WR_REG(0XF7);    
	LCD_WR_DATA(0xA9); 
	LCD_WR_DATA(0x51); 
	LCD_WR_DATA(0x2C); 
	LCD_WR_DATA(0x82);

	LCD_WR_REG(0x11);

	delay_ms(120);
	LCD_WR_REG(0x21); 
	LCD_WR_REG(0x29); 

	LCD_Scan_Dir(DFT_SCAN_DIR);		 
	//	LCD_LED=1;//	 
	LCD_Clear(WHITE);
	/*
	LCD_WR_REG(0X0C);		//read display pixel format		   
	DeviceCode=LCD_RD_DATA();//0XD3,ʵ0X93Ŷ.ǿȥ6λ   								   
	DeviceCode=LCD_RD_DATA();	
	*/
}  		  

int ReadData(void)
{
	//unsigned char dataL,dataH;
	int val;


	Clr_Cs;
	Set_Rs;        //
	Set_nWr;

	Clr_nRd;		//P1~P6			 
	delay_ms(500);
	
	val = GPIOE->IDR;
	
	Set_nRd; 
 	Set_Cs;

	return val;
}

void DispRegValue(unsigned int RegIndex,unsigned char ParNum)
{
	unsigned char i;
	unsigned int reg_data[20];	

	LCD_WR_REG(RegIndex);	  //ILI9481,BFh,P1~P6

	if(ParNum>20)
		ParNum=20;

	for(i=0;i<ParNum;i++)
	{
		reg_data[i]=ReadData();
	}


	//READ REG
	//DispStr("READ ID ",0,0,BLACK,WHITE);

	//DispStr("READ REG:0X",0,0,BLACK,WHITE);
	//DispInt(i,FONT_W*11,0,BLACK,WHITE);
    for(i=0;i<ParNum;i++)
	{
		//DispStr("0X",0,(16+1)*(i+1),BLUE,WHITE);
		//DispInt(reg_data[i],21*2,(16+1)*(i+1),BLUE,WHITE);
	}
}

  
//
//Color:Ҫɫ
void LCD_Clear(u16 Color)
{
	u32 index=0;      
	LCD_SetCursor(0x0,0x0,LCD_W, LCD_H);//ùλ 
	LCD_WriteRAM_Prepare();     //ʼдGRAM	 	  
	for(index=0;index<480*320;index++)
	{
		LCD_WR_DATA(Color);    
	}
}  
//ָָɫ
//С:(xend-xsta+1)*(yend-ysta+1)
//xsta
//color:Ҫɫ
void LCD_Fill(u16 sx,u16 sy,u16 ex,u16 ey,u16 color)
{          
	u16 i,j;
	u16 xlen=0;
	LCD_Scan_Dir(L2R_U2D);
#if USE_HORIZONTAL==1
	xlen=ey-sy+1;	   
	for(i=sx;i<=ex;i++)
	{
	 	LCD_SetCursor(i,sy,ex,ey);      				//ùλ 
		LCD_WriteRAM_Prepare();     			//ʼдGRAM	  
		for(j=0;j<xlen;j++)LCD_WR_DATA(color);	//ùλ 	  
	}
#else
	xlen=ex-sx+1;	   
	for(i=sy;i<=ey;i++)
	{
	 	LCD_SetCursor(sx,i,ex,ey);      				//ùλ 
		LCD_WriteRAM_Prepare();     			//ʼдGRAM	  
		for(j=0;j<xlen;j++)LCD_WR_DATA(color);	//ùλ 	    
	}
#endif
	LCD_Scan_Dir(DFT_SCAN_DIR);
}  

//
//x1,y1:
//x2,y2:յ  
void LCD_DrawLine(u16 x1, u16 y1, u16 x2, u16 y2)
{
	u16 t; 
	int xerr=0,yerr=0,delta_x,delta_y,distance; 
	int incx,incy,uRow,uCol; 

	delta_x=x2-x1; // 
	delta_y=y2-y1; 
	uRow=x1; 
	uCol=y1; 
	if(delta_x>0)incx=1; //õ 
	else if(delta_x==0)incx=0;//ֱ 
	else {incx=-1;delta_x=-delta_x;} 
	if(delta_y>0)incy=1; 
	else if(delta_y==0)incy=0;//ˮƽ 
	else{incy=-1;delta_y=-delta_y;} 
	if( delta_x>delta_y)distance=delta_x; //ѡȡ 
	else distance=delta_y; 
	for(t=0;t<=distance+1;t++ )// 
	{  
		LCD_DrawPoint(uRow,uCol);// 
		xerr+=delta_x ; 
		yerr+=delta_y ; 
		if(xerr>distance) 
		{ 
			xerr-=distance; 
			uRow+=incx; 
		} 
		if(yerr>distance) 
		{ 
			yerr-=distance; 
			uCol+=incy; 
		} 
	}  
}    
//
void LCD_DrawRectangle(u16 x1, u16 y1, u16 x2, u16 y2)
{
	LCD_DrawLine(x1,y1,x2,y1);
	LCD_DrawLine(x1,y1,x1,y2);
	LCD_DrawLine(x1,y2,x2,y2);
	LCD_DrawLine(x2,y1,x2,y2);
}
//ָλûһָСԲ
//(x,y):ĵ
//r    :뾶
void Draw_Circle(u16 x0,u16 y0,u8 r)
{
	int a,b;
	int di;
	a=0;b=r;	  
	di=3-(r<<1);             //ж¸λõı־
	while(a<=b)
	{
		LCD_DrawPoint(x0-b,y0-a);             //3           
		LCD_DrawPoint(x0+b,y0-a);             //0           
		LCD_DrawPoint(x0-a,y0+b);             //1       
		LCD_DrawPoint(x0-b,y0-a);             //7           
		LCD_DrawPoint(x0-a,y0-b);             //2             
		LCD_DrawPoint(x0+b,y0+a);             //4               
		LCD_DrawPoint(x0+a,y0-b);             //5
		LCD_DrawPoint(x0+a,y0+b);             //6 
		LCD_DrawPoint(x0-b,y0+a);             
		a++;
		//ʹBresenham㷨Բ     
		if(di<0)di +=4*a+6;	  
		else
		{
			di+=10+4*(a-b);   
			b--;
		} 
		LCD_DrawPoint(x0+a,y0+b);
	}
} 
//ָλʾһַ
//x:0~234
//y:0~308
//num:Ҫʾַ:" "--->"~"
//size:С 12/16
//mode:ӷʽ(1)Ƿǵӷʽ(0)
//ָλʾһַ
//x:0~234
//y:0~308
//num:Ҫʾַ:" "--->"~"
//size:С 12/16
//mode:ӷʽ(1)Ƿǵӷʽ(0)
void LCD_ShowChar(u16 x,u16 y,u8 num,u8 size,u8 mode)
{  
#if USE_HORIZONTAL==1
#define MAX_CHAR_POSX 479
#define MAX_CHAR_POSY 319 
#else     
#define MAX_CHAR_POSX 319	
#define MAX_CHAR_POSY 479
#endif 
    u8 temp;
    u8 pos,t;
	u16 x0=x;
	u16 colortemp=POINT_COLOR;      
    if(x>MAX_CHAR_POSX||y>MAX_CHAR_POSY)return;	    
	//ô		   
	num=num-' ';//õƫƺֵ
	if(!mode) //ǵӷʽ
	{
		for(pos=0;pos<size;pos++)
		{
			if(size==12)temp=asc2_1206[num][pos];//1206
			else temp=asc2_1608[num][pos];		 //1608
			for(t=0;t<size/2;t++)
		    {                 
		        if(temp&0x01)POINT_COLOR=colortemp;
				else POINT_COLOR=BACK_COLOR;
				LCD_DrawPoint(x,y);	
				temp>>=1; 
				x++;
		    }
			x=x0;
			y++;
		}	
	}else//ӷʽ
	{
		for(pos=0;pos<size;pos++)
		{
			if(size==12)temp=asc2_1206[num][pos];//1206
			else temp=asc2_1608[num][pos];		 //1608
			for(t=0;t<size/2;t++)
		    {                 
		        if(temp&0x01)LCD_DrawPoint(x+t,y+pos);//һ     
		        temp>>=1; 
		    }
		}
	}
	POINT_COLOR=colortemp;	    	   	 	  
}   
//m^n
u32 mypow(u8 m,u8 n)
{
	u32 result=1;	 
	while(n--)result*=m;    
	return result;
}			 
//ʾ2
//x,y :	 
//len :ֵλ
//size:С
//color:ɫ
//num:ֵ(0~4294967295);	 
void LCD_ShowNum(u16 x,u16 y,u32 num,u8 len,u8 size)
{         	
	u8 t,temp;
	u8 enshow=0;						   
	for(t=0;t<len;t++)
	{
		temp=(num/mypow(10,len-t-1))%10;
		if(enshow==0&&t<(len-1))
		{
			if(temp==0)
			{
				LCD_ShowChar(x+(size/2)*t,y,' ',size,0);
				continue;
			}else enshow=1; 
		 	 
		}
	 	LCD_ShowChar(x+(size/2)*t,y,temp+'0',size,0); 
	}
} 
//ʾ2
//x,y:
//size:С
//mode:ģʽ	0,ģʽ;1,ģʽ
//num:ֵ(0~99);	 
void LCD_Show2Num(u16 x,u16 y,u16 num,u8 len,u8 size,u8 mode)
{         	
	u8 t,temp;						   
	for(t=0;t<len;t++)
	{
		temp=(num/mypow(10,len-t-1))%10;
	 	LCD_ShowChar(x+(size/2)*t,y,temp+'0',size,mode); 
	}
} 
//ʾַ
//x,y:  
//*p:ַʼַ
//16
void LCD_ShowString(u16 x,u16 y,const u8 *p)
{         
    while(*p!='\0')
    {       
        if(x>MAX_CHAR_POSX){x=0;y+=16;}
        if(y>MAX_CHAR_POSY){y=x=0;LCD_Clear(WHITE);}
        LCD_ShowChar(x,y,*p,16,0);
        x+=8;
        p++;
    }  
}
